package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.institution.InstitutionDTO;
import cn.com.tenlion.systembase.pojo.dtos.teamuser.TeamUserDTO;
import cn.com.tenlion.systembase.pojo.vos.teamuser.TeamUserVO;
import cn.com.tenlion.systembase.service.institution.IInstitutionService;
import cn.com.tenlion.systembase.service.teamuser.ITeamUserService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0033 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private ITeamUserService teamUserService;
    @Autowired
    private IInstitutionService institutionService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0033() {}

    @KafkaListener(topics = "C0033FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<TeamUserDTO> teamUserDTOList = teamUserService.list(params);
        System.out.println(teamUserDTOList.size());
        if(null != teamUserDTOList && teamUserDTOList.size() > 0) {
            for(TeamUserDTO teamUserDTO: teamUserDTOList) {
                TeamUserVO teamUserVO = setData(teamUserDTO);
                teamUserService.saveKafka(teamUserDTO.getTeamUserId(), teamUserVO);
            }
        }
    }

    @KafkaListener(topics = "C0033")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            TeamUserDTO teamUserDTO = teamUserService.get(jsonObject.getString("uid"));
            TeamUserVO teamUserVO = setData(teamUserDTO);
            teamUserService.saveKafka(teamUserDTO.getTeamUserId(), teamUserVO);
        }else {
            institutionService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private TeamUserVO setData(TeamUserDTO teamUserDTO) {
        if(null == teamUserDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        InstitutionDTO institutionDTO = institutionService.get(teamUserDTO.getInstitutionId());
        TeamUserVO teamUserVO = new TeamUserVO();
        teamUserVO.setGrid(institutionDTO.getGrid());
        teamUserVO.setDepartment(institutionDTO.getInstitutionName());
        teamUserVO.setLocationCode(institutionDTO.getLocationCode());
        teamUserVO.setTeamUserName(teamUserDTO.getTeamUserName());
        teamUserVO.setTeamUserSexText(teamUserDTO.getTeamUserSexText());
        teamUserVO.setTeamUserPhone1(teamUserDTO.getTeamUserPhone1());
        return teamUserVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}